image: docker:19

services:
  - docker:dind

cache:
  paths:
    - ~/.gradle

stages:
  - test
  - build
  - deploy

before_script:
  - chmod +rwx ./gradlew
  - echo "=========================================================="

include:
  - template: Dependency-Scanning.gitlab-ci.yml

build jar:
  stage: build
  image: openjdk:14
  before_script:
    - chmod +rwx ./gradlew
  script:
    - ./gradlew :shadowJar
    - JAR=$(ls ./build/libs/)
    - cp ./build/libs/$JAR ./build/libs/Bot.jar
  artifacts:
    paths:
      - ./build/libs/Bot.jar
    expire_in: 2 week


build dockerfile:
  stage: deploy
  only:
    - master
  script:
    - echo "$CI_REGISTRY_PASSWORD" | docker login --username "$CI_REGISTRY_USER" --password-stdin docker.io
    - docker build --pull -t "index.docker.io/$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG" .
    - docker tag "index.docker.io/$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG" "index.docker.io/$CI_REGISTRY_IMAGE:latest"
    - docker push "index.docker.io/$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"
    - docker push "index.docker.io/$CI_REGISTRY_IMAGE:latest"
